package eu.maiora.model

import eu.maiora.db.*
import org.jetbrains.exposed.sql.Expression
import org.jetbrains.exposed.sql.LongColumnType
import org.jetbrains.exposed.sql.ResultRow
import org.jetbrains.exposed.sql.or

class ViewEcommerceValoreUsatoRepositoryImpl : ViewEcommerceValoreUsatoRepository {
    override suspend fun getValoreByIdArtIdClie(idCliente: Long, idArticolo : Long): List<ViewEcommerceValoreUsato>? = suspendTransaction {
        // Cerca il valore della carcassa dalla table function ViewEcommerceValoreUsatoTable

        val result = exec("SELECT * FROM dbo.Get_Valore_usato(?, ?)", listOf(
            LongColumnType() to idCliente,
            LongColumnType() to idArticolo
        )) { rs ->
            val list = mutableListOf<ViewEcommerceValoreUsato>()
            while (rs.next()) {
                val element : ViewEcommerceValoreUsato
                //if(idCliente == 10000023706){
                    element = ViewEcommerceValoreUsato(
                        id = rs.getLong("id"),
                        idCliente = rs.getLong("id_cliente"),
                        idArticolo = rs.getLong("id_articolo"),
                        valoreUsato = rs.getDouble("valore_usato")
                    )
                //}
                //else {
                    /*element = ViewEcommerceValoreUsato(
                        id = rs.getLong("id"),
                        idCliente = rs.getLong("id_cliente"),
                        idArticolo = rs.getLong("id_articolo"),
                        idMagazzino = rs.getLong("id_magazzino"),
                        magazzino = rs.getString("magazzino"),
                        valoreCarcassa = rs.getDouble("valore_carcassa"),
                        prezzo = rs.getDouble("prezzo"),
                        sconto = rs.getDouble("sconto"),
                        sconto1 = rs.getDouble("sconto_1"),
                        sconto2 = rs.getDouble("sconto_2"),
                        sconto3 = rs.getDouble("sconto_3"),
                        netto = rs.getDouble("netto"),
                        numeroPezzi = rs.getInt("numero_pezzi")
                    )*/
                //}


                list.add(element)

            }
            list
        }

        result?.ifEmpty { emptyList() }

    }
}